#include "exchangedata.h"

ExchangeData::ExchangeData()
{

    x = new QVector<double>(2000);
    y1 = new QVector<double>(2000);
    y2 = new QVector<double>(2000);
    y3 = new QVector<double>(2000);
    y4 = new QVector<double>(2000);

    ValueDelim1=1;
    ValueDelim2=1;
    ValueDelim3=1;
    ValueDelim4=1;

    step_dds = 0;

    speed_diff = 500;

    FreqGen = 1000000;

    timer_tick = 0;
    device_connect = false;

    work_pause=PAUSE; //
    work_stop=STOPED;

    hid = new hidControl();

}

QString ExchangeData::getError_usb()
{
    QString ret;
    mutex_usb.lock();
    ret = error_usb;
    mutex_usb.unlock();
    return ret;
}

void ExchangeData::setError_usb( QString &value)
{
    mutex_usb.lock();
    error_usb = value;
    mutex_usb.unlock();
}

int ExchangeData::getWork_pause()
{
    int ret;
    mutex_pause.lock();
    ret = work_pause;
    mutex_pause.unlock();
    return ret;
}

void ExchangeData::setWork_pause(int value)
{
    mutex_pause.lock();
    work_pause = value;
    mutex_pause.unlock();
}

int ExchangeData::getWork_stop()
{
    int ret;
    mutex_stop.lock();
    ret = work_stop;
    mutex_stop.unlock();
    return ret;
}

void ExchangeData::setWork_stop(int value)
{
    mutex_stop.lock();
    work_stop = value;
    mutex_stop.unlock();
}

bool ExchangeData::getChanelEnable1()
{
    bool ret;
    mutex_value.lock();
    ret = ChanelEnable1;
    mutex_value.unlock();
    return ret;
}

void ExchangeData::setChanelEnable1(bool value)
{
    mutex_value.lock();
    ChanelEnable1 = value;
    mutex_value.unlock();
}

bool ExchangeData::getChanelEnable2()
{
    bool ret;
    mutex_value.lock();
    ret = ChanelEnable2;
    mutex_value.unlock();
    return ret;
}

void ExchangeData::setChanelEnable2(bool value)
{
    mutex_value.lock();
    ChanelEnable2 = value;
    mutex_value.unlock();
}

bool ExchangeData::getChanelEnable3()
{
    bool ret;
    mutex_value.lock();
    ret = ChanelEnable3;
    mutex_value.unlock();
    return ret;
}

void ExchangeData::setChanelEnable3(bool value)
{
    mutex_value.lock();
    ChanelEnable3 = value;
    mutex_value.unlock();
}

bool ExchangeData::getChanelEnable4()
{
    bool ret;
    mutex_value.lock();
    ret = ChanelEnable4;
    mutex_value.unlock();
    return ret;
}

void ExchangeData::setChanelEnable4(bool value)
{
    mutex_value.lock();
    ChanelEnable4 = value;
    mutex_value.unlock();
}

double ExchangeData::getFreqGen()
{
    int ret;
    mutex_value.lock();
    ret = FreqGen;
    mutex_value.unlock();
    return ret;
}

void ExchangeData::setFreqGen(double value)
{
    mutex_value.lock();
    FreqGen = value;
    mutex_value.unlock();
}

int ExchangeData::getFreqStart()
{
    int ret;
    mutex_value.lock();
    ret = FreqStart;
    mutex_value.unlock();
    return ret;
}

void ExchangeData::setFreqStart(int value)
{
    mutex_value.lock();
    FreqStart = value;
    mutex_value.unlock();
}

int ExchangeData::getFreqStop()
{
    int ret;
    mutex_value.lock();
    ret = FreqStop;
    mutex_value.unlock();
    return ret;
}

void ExchangeData::setFreqStop(int value)
{
    mutex_value.lock();
    FreqStop = value;
    mutex_value.unlock();
}

int ExchangeData::getFreqStep()
{
    int ret;
    mutex_value.lock();
    ret = FreqStep;
    mutex_value.unlock();
    return ret;
}

void ExchangeData::setFreqStep(int value)
{
    mutex_value.lock();
    FreqStep = value;
    mutex_value.unlock();
}

int ExchangeData::getValueDelim1()
{
    int ret;
    mutex_value.lock();
    ret = ValueDelim1;
    mutex_value.unlock();
    return ret;
}

void ExchangeData::setValueDelim1(int value)
{
    mutex_value.lock();
    ValueDelim1 = value;
    mutex_value.unlock();
}

int ExchangeData::getValueDelim2()
{
    int ret;
    mutex_value.lock();
    ret = ValueDelim2;
    mutex_value.unlock();
    return ret;
}

void ExchangeData::setValueDelim2(int value)
{
    mutex_value.lock();
    ValueDelim2 = value;
    mutex_value.unlock();
}

int ExchangeData::getValueDelim3()
{
    int ret;
    mutex_value.lock();
    ret = ValueDelim3;
    mutex_value.unlock();
    return ret;
}

void ExchangeData::setValueDelim3(int value)
{
    mutex_value.lock();
    ValueDelim3 = value;
    mutex_value.unlock();
}

int ExchangeData::getValueDelim4()
{
    int ret;
    mutex_value.lock();
    ret = ValueDelim4;
    mutex_value.unlock();
    return ret;
}

void ExchangeData::setValueDelim4(int value)
{
    mutex_value.lock();
    ValueDelim4 = value;
    mutex_value.unlock();
}

double ExchangeData::getStep_dds()
{
    double ret;
    mutex_value.lock();
    ret = step_dds;
    mutex_value.unlock();
    return ret;
}

void ExchangeData::setStep_dds(double value)
{
    mutex_value.lock();
    step_dds = value;
    mutex_value.unlock();
}

int ExchangeData::getSpeed_diff()
{
    int ret;
    mutex_value.lock();
    ret = speed_diff;
    mutex_value.unlock();
    return ret;
}

void ExchangeData::setSpeed_diff(int value)
{
    mutex_value.lock();
    speed_diff = value;
    mutex_value.unlock();
}

unsigned int ExchangeData::getTimer_tick()
{
    unsigned int ret;
    mutex_value.lock();
    ret = timer_tick;
    mutex_value.unlock();
    return ret;
}

void ExchangeData::setTimer_tick(unsigned int value)
{
    mutex_value.lock();
    timer_tick = value;
    mutex_value.unlock();
}

QVector<double> *ExchangeData::getX()
{
    QVector<double> *ret;
    mutex_data_graph.lock();
    ret = x;
    mutex_data_graph.unlock();
    return ret;
}

void ExchangeData::setX(int index,int value)
{
    mutex_data_graph.lock();
    (*x)[index]=value;
    mutex_data_graph.unlock();
}

QVector<double> *ExchangeData::getY1()
{
    QVector<double> *ret;
    mutex_data_graph.lock();
    ret = y1;
    mutex_data_graph.unlock();
    return ret;
}

void ExchangeData::setY1(int index,int value)
{
    mutex_data_graph.lock();
    (*y1)[index]=value;
    mutex_data_graph.unlock();
}

QVector<double> *ExchangeData::getY2()
{
    QVector<double> *ret;
    mutex_data_graph.lock();
    ret = y2;
    mutex_data_graph.unlock();
    return ret;
}

void ExchangeData::setY2(int index,int value)
{
    mutex_data_graph.lock();
    (*y2)[index]=value;
    mutex_data_graph.unlock();
}

QVector<double> *ExchangeData::getY3()
{
    QVector<double> *ret;
    mutex_data_graph.lock();
    ret = y3;
    mutex_data_graph.unlock();
    return ret;
}

void ExchangeData::setY3(int index,int value)
{
    mutex_data_graph.lock();
    (*y3)[index]=value;
    mutex_data_graph.unlock();
}

QVector<double> *ExchangeData::getY4()
{
    QVector<double> *ret;
    mutex_data_graph.lock();
    ret = y4;
    mutex_data_graph.unlock();
    return ret;
}

void ExchangeData::setY4(int index,int value)
{
    mutex_data_graph.lock();
    (*y4)[index]=value;
    mutex_data_graph.unlock();
}

hidControl *ExchangeData::getHid()
{
    hidControl *ret;
    mutex_usb.lock();
    ret = hid;
    mutex_usb.unlock();
    return ret;
}

void ExchangeData::setHid(hidControl *value)
{
    mutex_usb.lock();
    hid = value;
    mutex_usb.unlock();
}

bool ExchangeData::getDevice_connect()
{
    bool ret;
    mutex_usb.lock();
    ret = device_connect;
    mutex_usb.unlock();
    return ret;
}

void ExchangeData::setDevice_connect(bool value)
{
    mutex_usb.lock();
    device_connect = value;
    mutex_usb.unlock();
}

int ExchangeData::getErr_usb_count()
{
    int ret;
    mutex_usb.lock();
    ret = err_usb_count;
    mutex_usb.unlock();
    return ret;
}

void ExchangeData::setErr_usb_count(int value)
{
    mutex_usb.lock();
    err_usb_count = value;
    mutex_usb.unlock();
}



bool ExchangeData::pause(bool enable){
    mutex_pause.lock();
    if (enable){
        work_pause = PAUSE;
    }else{
        work_pause = PAUSE_NO;
    }
    mutex_pause.unlock();

    return true;

}

bool ExchangeData::stop(){
    mutex_stop.lock();
    if (work_stop == STOP_NO ){
        work_stop = STOP;
    }
    mutex_stop.unlock();

    while(getWork_stop() != STOPED) sleep(1);
    return true;

}






bool ExchangeData::connect(){
    bool res=true;
    if (!device_connect){
        if (hid->init(VID_NUMBER,PID_NUMBER) < 0){
            /// Ошибка
            device_connect = false;
            error_usb = hid->error_usb;
            error_usb += "Connect error";
        }else{
            // Подключимлся
            device_connect = true;
            err_usb_count = 0;
        }
    res = false;
    };
    if (err_usb_count > 10){
        device_connect = false;
        res=false;
    }

    return res;
}


void ExchangeData::run(){

    ExchangeData* exchangeData = this;

    exchangeData->setWork_stop(STOP_NO);

    unsigned int next=0;
    unsigned int this_freq=0;

    struct dataexchange_t  *data = (struct dataexchange_t*) ((exchangeData->getHid()->buf)+1);

    while (exchangeData->getWork_stop() == STOP_NO){
    if (exchangeData->getWork_pause() == PAUSE_NO){
    if (exchangeData->getDevice_connect()){

        exchangeData->setTimer_tick(exchangeData->getTimer_tick()+1);

        if (exchangeData->getTimer_tick() > 1999){
            exchangeData->setTimer_tick(0);
            next = 0;
        }

     if (next <= exchangeData->getTimer_tick())
        // Если следующий шаг то пропускаем в получение данных
     {
        next = exchangeData->getTimer_tick() + exchangeData->getFreqStep();
        data->data1 = 0;
        exchangeData->step_dds= (((double)(exchangeData->getFreqStop() - exchangeData->getFreqStart()) / 2000)* (double)exchangeData->getTimer_tick() + exchangeData->getFreqStart());

        /////  Устанавливаем частоту DDS
        data->data1 = (long) exchangeData->step_dds;
        //// Устанавливаем какие включены ADC
        // ADC0 - 0b00000001
        // ADC1 - 0b00000010
        // ADC2 - 0b00000100
        // ADC2 - 0b00001000
        // Быстрый режим ождин опрос ADC за проход (Если скорость более 250)
        // FAST_REC - 0b1000xxxx
        // БЫстрый режим с уменьшенной частотой деления на ADC (Если скорость более 350)
        // FAST_DIV - 0b0100xxxx

        data->data2 = 0;
        if(exchangeData->getChanelEnable1()){
             data->data2 |= (1 << ADC0_EN);
        }
        if(exchangeData->getChanelEnable2()){
            data->data2 |= (1 << ADC1_EN);
        }
        if(exchangeData->getChanelEnable3()){
            data->data2 |= (1 << ADC2_EN);
        }
        if(exchangeData->getChanelEnable4()){
            data->data2 |= (1 << ADC3_EN);
        }

        if (exchangeData->getSpeed_diff() > 250){
             data->data2 |= (1 << FAST_REC);
        }

        if (exchangeData->getSpeed_diff() > 450){
            data->data2 |= (1 << FAST_DIV);
        }

        if (exchangeData->getSpeed_diff() > 1){
        if (exchangeData->hid->write() == -1){
             exchangeData->setErr_usb_count(exchangeData->getErr_usb_count()+1);


        }else{
            usleep(10*exchangeData->getSpeed_diff());
            data->data1 = 0L;
        }
        };



         if (exchangeData->hid->read() == -1){
              exchangeData->setErr_usb_count(exchangeData->getErr_usb_count()+1);
            }else{
                 exchangeData->setErr_usb_count(0);

          }

    }

         if (exchangeData->getChanelEnable1()) (*exchangeData->getY1())[exchangeData->getTimer_tick()] = (data->data1 >> 16) / exchangeData->getValueDelim1();
         if (exchangeData->getChanelEnable2())(*exchangeData->getY2())[exchangeData->getTimer_tick()] = ((data->data1 << 16)>> 16) / exchangeData->getValueDelim2();
         if (exchangeData->getChanelEnable3())(*exchangeData->getY3())[exchangeData->getTimer_tick()] = (data->data2 >>16) / exchangeData->getValueDelim3();
         if (exchangeData->getChanelEnable4())(*exchangeData->getY4())[exchangeData->getTimer_tick()] = ((data->data2 << 16) >> 16) / exchangeData->getValueDelim4();



    }
    }else{
       next = 0;
       sleep(1);
       if (exchangeData->getDevice_connect()){
       if (this_freq != exchangeData->getFreqGen()){
            this_freq = exchangeData->getFreqGen();
            /////  Устанавливаем частоту DDS
            data->data1 = this_freq;
            /// Выключаем все ADC
            data->data2 = 0;
                if (exchangeData->getSpeed_diff() > 1){
                    if (exchangeData->hid->write() == -1){
                         exchangeData->setErr_usb_count(exchangeData->getErr_usb_count()+1);
                    }
                    data->data1 = 0L;
                }
            }

       }
    }


    }

    exchangeData->setWork_stop(STOPED);

}

